'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _join = require('../../utils/join');

var _join2 = _interopRequireDefault(_join);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactFlex = require('react-flex');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DragHelper = require('drag-helper');

var IS_MAC = global && global.navigator && global.navigator.appVersion && global.navigator.appVersion.indexOf("Mac") != -1;
var IS_FIREFOX = global && global.navigator && global.navigator.userAgent && !! ~global.navigator.userAgent.toLowerCase().indexOf('firefox');

var Scroller = function (_Component) {
  _inherits(Scroller, _Component);

  function Scroller() {
    _classCallCheck(this, Scroller);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Scroller).apply(this, arguments));
  }

  _createClass(Scroller, [{
    key: 'render',
    value: function render() {
      var props = this.props;

      var itemHeight = props.itemHeight;
      var dataLength = props.dataLength;
      var contentHeight = props.contentHeight;
      var scrollTop = props.scrollTop;
      var height = props.height;
      var scrollbarWidth = props.scrollbarWidth;

      var scrollContentStyle = {
        height: contentHeight
      };

      var contentStyle = {
        maxHeight: height,
        maxWidth: 'calc(100% - ' + scrollbarWidth + 'px)'
      };

      var scrollerStyle = {
        height: height,
        maxHeight: height,
        maxWidth: scrollbarWidth
      };

      return _react2.default.createElement(
        _reactFlex.Flex,
        {
          row: true,
          wrap: false,
          alignItems: 'stretch',
          className: 'react-datagrid__scroller'

        },
        _react2.default.createElement(
          _reactFlex.Flex,
          {
            flex: 1,
            className: 'react-datagrid__scroller__content',
            alignItems: 'stretch',
            wrap: false,
            ref: 'viewport',
            onWheel: this.onWheel,
            style: contentStyle
          },
          props.children
        ),
        _react2.default.createElement(
          'div',
          {
            ref: 'scrollbar',
            className: 'react-datagrid__scroller__scrollbar',
            onScroll: this.onScrollBarScroll,
            style: scrollerStyle
          },
          _react2.default.createElement('div', {
            className: 'react-datagrid__scroller__scrollbar__content',
            ref: 'scrollBarContent',
            style: scrollContentStyle
          })
        )
      );
    }
  }, {
    key: 'onScrollBarScroll',
    value: function onScrollBarScroll(event) {
      this.onScroll(this.normalizeScrollTop(event.target.scrollTop), event);
    }
  }, {
    key: 'onWheel',
    value: function onWheel(event) {
      var props = this.props;
      var scrollStep = props.scrollStep;
      var scrollTop = props.scrollTop;
      var maxScrollTop = props.maxScrollTop;
      var deltaY = event.deltaY;
      var deltaX = event.deltaX;

      // horizontal scroll is native so do nothing

      if (~ ~deltaX !== 0) {
        return;
      }

      event.preventDefault();

      var newScrollTop = scrollTop;

      if (deltaY < 0) {
        newScrollTop += deltaY * scrollStep;
      } else {
        newScrollTop += deltaY * scrollStep;
      }

      newScrollTop = this.normalizeScrollTop(newScrollTop);

      // don't trigger onscroll value doen't change
      // it happens when scrolltop is normalized to 0 or maxScrollTop
      if (newScrollTop != scrollTop) {
        this.onScroll(newScrollTop);
      }
    }
  }, {
    key: 'onScroll',
    value: function onScroll(scrollTop, event) {
      this.props.onScroll(scrollTop, event);
    }
  }, {
    key: 'setScroll',
    value: function setScroll(scrollTop) {
      (0, _reactDom.findDOMNode)(this.refs.scrollbar).scrollTop = scrollTop;
    }

    // TODO test on ipad

  }, {
    key: 'onTouchStart',
    value: function onTouchStart(event) {
      var props = this.props;
      var side;

      DragHelper(event, {
        scope: this,
        onDrag: function onDrag(event, config) {
          if (config.diff.top == 0 && config.diff.left == 0) {
            return;
          }

          if (!side) {
            side = ABS(config.diff.top) > ABS(config.diff.left) ? 'top' : 'left';
          }

          var diff = config.diff[side];

          newScrollPos = scroll[side] - diff;

          if (side == 'top') {
            this.onScroll(newScrollPos, event);
          }
        }
      });

      event.stopPropagation();
      preventDefault(event);
    }
  }, {
    key: 'normalizeScrollTop',
    value: function normalizeScrollTop(scrollTop) {
      var maxScrollTop = this.props.maxScrollTop;

      var newScrollTop = ~ ~scrollTop;

      if (newScrollTop < 0) {
        newScrollTop = 0;
      }

      if (newScrollTop > maxScrollTop) {
        newScrollTop = maxScrollTop;
      }

      return newScrollTop;
    }
  }]);

  return Scroller;
}(_reactClass2.default);

Scroller.defaultProps = {
  scrollStep: IS_FIREFOX ? 40 : 1
};

Scroller.propTypes = {
  className: _react.PropTypes.string,
  scrollTop: _react.PropTypes.number,
  scrollStep: _react.PropTypes.number
};

exports.default = Scroller;